"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@ts-ioc/core");
var decorators_1 = require("../decorators");
var IMiddleware_1 = require("./IMiddleware");
var IApplication_1 = require("../IApplication");
var IConfiguration_1 = require("../../IConfiguration");
var aop_1 = require("@ts-ioc/aop");
var platform_server_1 = require("@ts-ioc/platform-server");
var serve = require('koa-static');
var DefaultContentMiddleware = /** @class */ (function () {
    function DefaultContentMiddleware() {
    }
    DefaultContentMiddleware.prototype.setup = function () {
        var _this = this;
        var contents = this.config.contents || ['./public'];
        contents.forEach(function (content, idx) {
            var staticPath = platform_server_1.toAbsolutePath(_this.config.rootdir, content);
            console.log("content path " + (idx + 1) + ":", staticPath);
            _this.app.use(serve(staticPath));
        });
    };
    DefaultContentMiddleware.classAnnations = { "name": "DefaultContentMiddleware", "params": { "constructor": [], "setup": [] } };
    tslib_1.__decorate([
        core_1.Inject(IApplication_1.ApplicationToken),
        tslib_1.__metadata("design:type", Object)
    ], DefaultContentMiddleware.prototype, "app", void 0);
    tslib_1.__decorate([
        core_1.Inject(IConfiguration_1.ConfigurationToken),
        tslib_1.__metadata("design:type", Object)
    ], DefaultContentMiddleware.prototype, "config", void 0);
    DefaultContentMiddleware = tslib_1.__decorate([
        aop_1.NonePointcut,
        decorators_1.Middleware(IMiddleware_1.ContentMiddlewareToken),
        tslib_1.__metadata("design:paramtypes", [])
    ], DefaultContentMiddleware);
    return DefaultContentMiddleware;
}());
exports.DefaultContentMiddleware = DefaultContentMiddleware;

//# sourceMappingURL=../../sourcemaps/core/middlewares/DefaultContentMiddleware.js.map
