"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@ts-ioc/core");
var index_1 = require("../decorators/index");
var ControllerRoute_1 = require("./ControllerRoute");
var aop_1 = require("@ts-ioc/aop");
var RouteBuilder = /** @class */ (function () {
    function RouteBuilder() {
    }
    RouteBuilder.prototype.build = function (router) {
        var controllers = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            controllers[_i - 1] = arguments[_i];
        }
        var root = router.getRoot();
        var contrkey = index_1.Controller.toString();
        controllers.forEach(function (ctrl) {
            if (core_1.isClass(ctrl)) {
                var ctrlmetadatas = core_1.getTypeMetadata(contrkey, ctrl);
                ctrlmetadatas.forEach(function (ctlmeta) {
                    if (!ctlmeta) {
                        return;
                    }
                    var prefix = ctlmeta.routePrefix;
                    if (prefix && !/^\//.test(prefix)) {
                        prefix = '/' + prefix;
                    }
                    var route = root.match(prefix);
                    var ctrlRoute = new ControllerRoute_1.ControllerRoute(prefix, ctrl);
                    if (route.isEmpty()) {
                        root.add(new ControllerRoute_1.ControllerRoute(prefix, ctrl));
                    }
                    else {
                        route.add(new ControllerRoute_1.ControllerRoute(prefix, ctrl));
                    }
                });
            }
        });
        return root;
    };
    RouteBuilder.classAnnations = { "name": "RouteBuilder", "params": { "constructor": [], "build": ["router", "controllers"] } };
    RouteBuilder = tslib_1.__decorate([
        aop_1.NonePointcut,
        core_1.Injectable,
        tslib_1.__metadata("design:paramtypes", [])
    ], RouteBuilder);
    return RouteBuilder;
}());
exports.RouteBuilder = RouteBuilder;

//# sourceMappingURL=../../sourcemaps/core/router/RouteBuilder.js.map
