"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var IApplication_1 = require("../IApplication");
var index_1 = require("../decorators/index");
var core_1 = require("@ts-ioc/core");
var RootRoute_1 = require("./RootRoute");
var RouteBuilder_1 = require("./RouteBuilder");
var IConfiguration_1 = require("../../IConfiguration");
/**
 * Router middleware token.
 */
exports.RouterMiddlewareToken = new core_1.InjectToken('__MVC_Middleware_Router');
var Router = /** @class */ (function () {
    function Router(builder, config) {
        this.builder = builder;
        this.config = config;
        this.root = new RootRoute_1.RootRoute(config.routePrefix);
    }
    Router.prototype.routes = function (map) {
        this.root.add(map);
    };
    Router.prototype.register = function () {
        var controllers = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            controllers[_i] = arguments[_i];
        }
        var _a;
        (_a = this.builder).build.apply(_a, [this].concat(controllers));
    };
    Router.prototype.setup = function () {
        var _this = this;
        this.app.use(function (ctx, next) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                if ((!ctx.status || ctx.status === 404) && this.config.isRouteUrl(ctx.url)) {
                    return [2 /*return*/, this.root.navigating(this.app.container, ctx, next)];
                }
                return [2 /*return*/];
            });
        }); });
    };
    Router.prototype.getRoot = function () {
        return this.root;
    };
    Router.classAnnations = { "name": "Router", "params": { "constructor": ["builder", "config"], "routes": ["map"], "register": ["controllers"], "setup": [], "getRoot": [] } };
    tslib_1.__decorate([
        core_1.Inject(IApplication_1.ApplicationToken),
        tslib_1.__metadata("design:type", Object)
    ], Router.prototype, "app", void 0);
    Router = tslib_1.__decorate([
        index_1.Middleware(exports.RouterMiddlewareToken),
        tslib_1.__param(1, core_1.Inject(IConfiguration_1.ConfigurationToken)),
        tslib_1.__metadata("design:paramtypes", [RouteBuilder_1.RouteBuilder, Object])
    ], Router);
    return Router;
}());
exports.Router = Router;

//# sourceMappingURL=../../sourcemaps/core/router/Router.js.map
